#include <sstream>
#include "testlib.h"

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int N = inf.readInt(1, 1e5, "N");
    inf.readSpace();
    long long K = inf.readLong(1LL, (long long)(1e10), "K");
    inf.readEoln();

    int remaining = 1e5;
    for (int i = 0; i < N; i++) {
        int L = inf.readInt(1, 1e5, "L");
        inf.readEoln();

        std::vector<std::string> books (L);
        for (int j = 0; j < L; j++) {
            int M = inf.readInt(1, std::min(60, remaining), "M");
            remaining -= M;
            inf.readSpace();

            std::ostringstream pattern;
            pattern << "[a-z0-9\\ ]{" << M << "}";
            inf.readLineTo(books[j], pattern.str(), "B");
        }
    }

    inf.readEof();
}
