#include "testlib.h"
#include <numeric>
#include <cassert>
#include <iostream>

using namespace std;

typedef long long ll;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int N;
    if (argc > 2) {
        N = atoi(argv[2]);
    } else {
        N = rnd.next(1, int(1e5));
    }
    cout << N << "\n";
    cout << rnd.next(format("[0-9]{%d}", N)) << "\n";

    int LL = -1, LH = -1;
    if (argc > 5) {
        LL = atoi(argv[4]);
        LH = atoi(argv[5]);
    }

    int OPL = 1;
    int OPH = 3;
    if (argc > 7) {
        OPL = atoi(argv[6]);
        OPH = atoi(argv[7]);
    }

    int Q = -1;
    if (argc > 3) {
        Q = atoi(argv[3]);
    }
    if (Q == -1) {
        Q = rnd.next(1, int(1e5));
    }
    cout << Q << "\n";
    while (Q--) {
        int O = rnd.next(OPL, OPH);

        if (O == 3) {
            int P = rnd.next(1, N);
            int D = rnd.next(0, 9);

            cout << O << " " << P << " " << D << "\n";
        } else {
            int A1 = rnd.next(1, LL != -1 ? LL : N);
            int B1 = rnd.next(LH != -1 ? max(LH, A1) : A1, N);

            int A2 = rnd.next(1, LL != -1 ? LL : N);
            int B2 = rnd.next(LH != -1 ? max(LH, A2) : A2, N);

            int D = rnd.next(0, 8);

            cout << O << " " << A1 << " " << B1 << " " << A2 << " " << B2 << " " << D << "\n";
        }
    }
}
