#include <bits/stdc++.h>
using namespace std;

int main(int argc, char** argv) {
    const std::string CHARACTERS = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789 .,+-*=/(){}[]<>";

    unsigned long long seed = (atoi(argv[1]) * 0x5DEECE66DLL) + 0xBLL;

    if (argc >= 3) {
        seed += atoi(argv[2]) + 0xBLL;
    }

    std::mt19937 generator(seed);
    std::uniform_int_distribution<> distribution(0, CHARACTERS.size() - 1);

    std::uniform_int_distribution<> n_generation(1, 1e6);
    int N = n_generation(generator);
    if (argc >= 3) {
        N = atoi(argv[2]);
    }

    std::string random_string;
    
    std::uniform_int_distribution<> initial_distribution(0, 26+26-1);
    random_string += CHARACTERS[initial_distribution(generator)];

    for (std::size_t i = 1; i < N; ++i) {
        char ch;
        do {
            ch = CHARACTERS[distribution(generator)];
        } while ((i == N-1 || random_string[i-1] == ' ') && ch == ' ');
        random_string += ch;
    }

    cout << N << "\n";
    cout << random_string << "\n";
}
