#include <sstream>
#include "testlib.h"

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int N = inf.readInt(1, 1e6, "N");
    inf.readEoln();

    long long last_P = 0;
    int last_M;
    for (int i = 0; i < N; i++) {
        int M = inf.readInt(4, 1e8, "M");
        inf.readSpace();
        long long P = inf.readLong(0, (long long)(1e10), "P");
        inf.readEoln();

        if (i == N-1) {
            if (P != 0) {
                quitf(_fail, "P should be 0 at the end");
            }
        } else if (!(P >= last_P + M)) {
            quitf(_fail, "P overlaps: We are at %lld, and P is at %lld", last_P+M, P);
        }
        last_P = P;
        last_M = M;
    }

    inf.readInt(0, 1e8, "T");
    inf.readEoln();

    inf.readEof();
}
