#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

vector<ll> ft (1e5+15);

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    ll k;
    cin >> n >> k;

    vector<ll> inv (n);
    for (int i = 0; i < n; i++) {
        int l;
        cin >> l;

        vector<pair<string, int>> books (l);
        for (int j = 0; j < l; j++) {
            int m;
            cin >> m >> ws;

            string s;
            getline(cin, s);
            books[j] = make_pair(s, j);
        }

        sort(books.begin(), books.end());

        fill(ft.begin(), ft.end(), 0);

        ll res = 0;
        for (int k = 0; k < l; k++) {
            int x = books[k].second;
            for (int m = x+1; m < l+1; m++) {
                res += ft[m];
            }
            ft[x] += 1;
        }
        inv[i] = res;
    }

    vector<pair<ll, int>> inv_sorted (n);
    for (int i = 0; i < n; i++) {
        inv_sorted[i] = make_pair(-inv[i], i);
    }
    sort(inv_sorted.begin(), inv_sorted.end());

    ll total = accumulate(inv.begin(), inv.end(), 0LL);
    vector<ll> allocation (n);

    if (total > 0) {
        int notzeros = 0;
        for (int i = 0; i < n; i++) if (inv[i] > 0) {
            allocation[i] = 1;
            notzeros++;
        }

        ll remaining = k;
        for (int i = 0; i < n; i++) {
            ll res;
            assert(!__builtin_smulll_overflow(k-notzeros, inv[i], &res));
            allocation[i] += res/total;
            remaining -= allocation[i];
        }

        for (int i = 0; i < n && remaining > 0; i++) {
            allocation[inv_sorted[i].second]++;
            remaining--;
        }

        assert(accumulate(allocation.begin(), allocation.end(), 0LL) == k);
    }

    for (int i = 0; i < n; i++) {
        if (inv[i] > 0) { assert(allocation[i] > 0); }
        cout << allocation[i] << "\n";
    }
}
