#include <bits/stdc++.h>
using namespace std;

int main(int argc, char** argv) {
    unsigned long long seed = (atoi(argv[1]) * 0x5DEECE66DLL) + 0xBLL;
    if (argc >= 3) { seed += atoi(argv[2]) + 0xBLL; }
    if (argc >= 4) { seed += atoi(argv[3]) + 0x123; }

    std::mt19937 generator(seed);

    std::uniform_int_distribution<> n_generation(1, 1e6);

    int N = n_generation(generator);
    if (argc >= 3) { N = atoi(argv[2]); }
    int G = N/4;
    if (argc >= 4) { G = atoi(argv[3]); }

    std::vector<std::string> sets = {
        "ABCDEFGHIJKLMNOPQRSTUVWXYZ",
        "abcdefghijklmnopqrstuvwxyz",
        " .,(){}[]<>",
        "0123456789+-*=/",
    };

    std::vector<std::uniform_int_distribution<int>> distributions = {
        std::uniform_int_distribution<int>{0, int(sets[0].size())-1},
        std::uniform_int_distribution<int>{0, int(sets[1].size())-1},
        std::uniform_int_distribution<int>{0, int(sets[2].size())-1},
        std::uniform_int_distribution<int>{0, int(sets[3].size())-1}
    };

    std::uniform_int_distribution<> group_type(0, 3);
    std::uniform_int_distribution<> initial_group_type(0, 1);
    std::uniform_int_distribution<> grouping(1, G);

    std::string random_string (N, '\0');

    int i = 0;
    while (i < N) {
         int group = i == 0 ? initial_group_type(generator) : group_type(generator);
         int group_size = grouping(generator);
         for (int j = 0; j < group_size && i < N; i++, j++) {
             char ch;
             do {
                ch = sets[group][(distributions[group])(generator)];
             } while (((i >= 1 && random_string[i-1] == ' ') || i == N-1) && ch == ' ');
             random_string[i] = ch;
         }
    }

    cout << N << "\n";
    cout << random_string << "\n";
}
