#include "testlib.h"
#include <numeric>
#include <cassert>
#include <iostream>

using namespace std;

typedef long long ll;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    vector<string> alphabet = {
        "[A-Z]",
        "[A-Za-z ]",
        "[W-Zw-z]",
        "[0-90012a-z]",
        "[0-9a-z]",
        "[a771xzji1zj oi2jx3io]",
        "[^123]",
        "[12345123]",
        "[as8d9 123]",
        " "
    };

    for (char c = 'a'; c <= 'z'; c++) { alphabet.push_back(string(1, c)); }
    for (char c = 'A'; c <= 'Z'; c++) { alphabet.push_back(string(1, c)); }

    int N = 100;
    cout << N << "\n";
    string pattern;
    while (N) {
        int i = rnd.next(0, int(alphabet.size())-1);
        if (N-int(alphabet[i].size()) < 0) { continue; }
        N -= alphabet[i].size();
        pattern += alphabet[i];
    }
    cout << pattern << "\n";

    int Q = 1000;
    cout << Q << "\n";

    while (Q--) {
        cout << "100 " << rnd.next("[A-Za-z0-9 ]{100}") << "\n";
    }
}
